﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using WcfContracts;
using System.ServiceModel;
using System.ServiceModel.Description;
using WcfServicesLib;

namespace WcfCaller
{
    class Program
    {
        static void Main(string[] args)
        {
            try
            {
                WSHttpBinding securedBinding = new WSHttpBinding(SecurityMode.TransportWithMessageCredential);
                securedBinding.Security.Message.ClientCredentialType = MessageCredentialType.Windows;
                securedBinding.Security.Message.NegotiateServiceCredential = true;
                securedBinding.Security.Transport.ClientCredentialType = HttpClientCredentialType.None;

                WSHttpBinding defaultBinding = new WSHttpBinding();


                //WSHttpBinding unSecuredBinding = new WSHttpBinding(SecurityMode.None);
                //unSecuredBinding.Security.Message.ClientCredentialType = MessageCredentialType.None;
                //unSecuredBinding.Security.Message.NegotiateServiceCredential = false;
                //unSecuredBinding.Security.Transport.ClientCredentialType = HttpClientCredentialType.None;



                EndpointAddress ep = new EndpointAddress(new Uri(@"http://{machinename}:27050/services/sampleservice.svc"),
                                                            EndpointIdentity.CreateUpnIdentity("EUR\\NG71534"),
                                                            System.ServiceModel.Channels.AddressHeader.CreateAddressHeader(null)
                                                            );


                EndpointAddress nep = new EndpointAddress(new Uri(@"http://{machinename}:27050/services/sampleservice.svc"),

                                                           System.ServiceModel.Channels.AddressHeader.CreateAddressHeader(null)
                                                           );
                ServiceEndpoint sep = new ServiceEndpoint(ContractDescription.GetContract(typeof(WcfContracts.ISampleService)), defaultBinding, nep);

                ChannelFactory<ISampleService> factory = new ChannelFactory<ISampleService>(sep);
                ISampleService channel = factory.CreateChannel();


            }
            catch (Exception e)
            {



                throw;
            }

        }



    }
}
