﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using WcfContracts;
using System.ServiceModel;
using System.IO;
using System.Security.Principal;
using System.Security.Permissions;

namespace WcfServicesLib
{
    public class SampleService : ISampleService
    {

        public string GetValue(string value)
        {


            #region enumerate all NT Groups for the user

            if (ServiceSecurityContext.Current != null)
            {
                Console.WriteLine("Caller Identity:{0}", ServiceSecurityContext.Current.PrimaryIdentity.Name);
                WindowsIdentity windowsIdentity = ServiceSecurityContext.Current.PrimaryIdentity as WindowsIdentity;
                if (windowsIdentity != null)
                {
                    WindowsPrincipal windowsPrincipal = new WindowsPrincipal(windowsIdentity);
                    IdentityReferenceCollection allGroups = windowsIdentity.Groups.Translate(typeof(NTAccount));

                }
            }

            #endregion

            return ReturnValue(value);

        }

        private string ReturnValue(string value)
        {
            string retVal = "Calling User:{0} Returning:{1}";

            if (ServiceSecurityContext.Current != null)
            {
                return String.Format(retVal, ServiceSecurityContext.Current.PrimaryIdentity.Name, value.ToString());
            }
            else
                return String.Format(retVal, ServiceSecurityContext.Anonymous.PrimaryIdentity.Name, value.ToString());

        }
        //[PrincipalPermission(SecurityAction.Demand, Role = @"EUR\Domain Users")]
        public string GetValueSecurely(string value)
        {
            return ReturnValue(value);
        }


    }
}
